﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IRaCIS.Core.Application.Service.Reading.Dto
{
    public class GetCRCSubjectClinicalInDto
    {
        public Guid SubjectId { get; set; }

        public Guid TrialId { get; set; }
    }


    public class GetCRCSubjectClinicalOutDto
    {
        public Guid ClinicalDataTrialSetId { get; set; }

        public string ClinicalDataSetName { get; set; }

        public int ClinicalCount { get; set; }
    }




    public class GetClinicalQuestionAnswerListInDto
    {
        public Guid SubjectId { get; set; }

        public Guid ClinicalDataTrialSetId { get; set; }
    }


    public class GetClinicalQuestionAnswerListOutDto
    {
        public List<TrialClinicalQuestionDto> QuestionList { get; set; }

        public List<Dictionary<string, string>> AnswerList { get; set; }
    }

    public class GetClinicalFormInfoInDto
    {
        public Guid ClinicalFormId { get; set; }
    }

    public class GetClinicalFormInfoOutDto
    {
        public List<ClinicalQuestionPreviewDto> Question { get; set; }
    }

    public class ClinicalFormQuestionAnswer
    {
        public Guid QuestionId { get; set; }

        public string Answer { get; set; } = string.Empty;
    }

    public class ClinicalFormTableQuestionAnswer
    {
        public Guid TableQuestionId { get; set; }

        public int RowIndex { get; set; }

        public Guid QuestionId { get; set; }

        public string Answer { get; set; } = string.Empty;
    }

    public class SubmitClinicalFormInDto
    {
        /// <summary>
        /// VisitId
        /// </summary>
        public Guid? VisitId { get; set; }

        /// <summary>
        /// VisitId
        /// </summary>
        public Guid? ReadingId { get; set; }

        public Guid? ClinicalFormId { get; set; }

        public Guid SubjectId { get; set; }

        public Guid ClinicalDataTrialSetId { get; set; }


        public List<ClinicalFormQuestionAnswer> QuestionAnswers { get; set; }

        public List<ClinicalQuestionForm> TableQuestionAnswerList { get; set; }
    }


    public class ClinicalQuestionForm
    {
        public Guid QuestionId { get; set; }

        public List<List<ClinicalTableQuestionForm>> TableQuestionAnswers { get; set; }
    }


    public class ClinicalTableQuestionForm
    {
        public Guid TableQuestionId { get; set; }

        public string Answer { get; set; } = string.Empty;
    }
}
